#include <stdio.h>
#include <string.h>
#include "unzip.h"

static unzFile unzfile = NULL;

int zip_open(const char *name)
{
	unzfile = unzOpen(name);
	if (unzfile != NULL) return 0;
	return -1;
}

int zip_close(void)
{
	if (unzfile != NULL)
		unzClose(unzfile);
	unzfile = NULL;
}

int zopen(const char *filename)
{
	if (unzfile == NULL) return -1;

	if (unzLocateFile(unzfile, filename, 2) == UNZ_OK)
		if (unzOpenCurrentFile(unzfile)== UNZ_OK)
			return 0;

	return -1;
}

int zsize(void)
{
	unz_file_info info;
	if (unzfile == NULL) return 0;

	unzGetCurrentFileInfo(unzfile, &info, NULL, 0, NULL, 0, NULL, 0);
	return info.uncompressed_size;
}

int zread(void * buf, unsigned size)
{
	if (unzfile == NULL) return -1;

	return unzReadCurrentFile(unzfile,buf,size);
}

int zclose(void)
{
	if (unzfile == NULL) return 0;
	return unzCloseCurrentFile(unzfile);
}
