/******************************************************************************

	inptport.c

	NEOGEO CDZ ݣȫ߫죭

******************************************************************************/

#include "neocd.h"


/******************************************************************************
	Ыܨ
******************************************************************************/

int option_controller;
u8 ALIGN_DATA neogeo_port_value[NCDZ_PORT_MAX];

int af_interval = 1;
int analog_sensitivity;	// not used


/******************************************************************************
	ܨ
******************************************************************************/

static const u8 hotkey_mask[11] =
{
//	0xef,	// A
//	0xdf,	// B
//	0xbf,	// C
//	0x7f,	// D
	0xcf,	// A+B
	0xaf,	// A+C
	0x6f,	// A+D
	0x9f,	// B+C
	0x5f,	// B+D
	0x3f,	// C+D
	0x8f,	// A+B+C
	0x4f,	// A+B+D
	0x2f,	// A+C+D
	0x1f,	// B+C+D
	0x0f	// A+B+C+D
};

static u8 ALIGN_DATA input_flag[MAX_INPUTS];
static int ALIGN_DATA af_flag[2][NCDZ_BUTTON_MAX];
static int ALIGN_DATA af_counter[2][NCDZ_BUTTON_MAX];
static int input_ui_wait;

/******************************************************************************
	μ
******************************************************************************/

/*------------------------------------------------------
	֧ҫի髰
------------------------------------------------------*/

static u32 update_autofire(u32 buttons)
{
	int i;

	for (i = 0; i < NCDZ_BUTTON_MAX; i++)
	{
        if(buttons & (1 << (P1_AF_A + i))) {
			af_counter[option_controller][i]++;

			if (af_counter[option_controller][i] >= af_interval)
			{
				af_counter[option_controller][i] = 0;
				af_flag[option_controller][i] ^= 1;
			}

			if (af_flag[option_controller][i])
				buttons &= ~(1 << (P1_BUTTONA + i));
			else
				buttons |= (1 << (P1_BUTTONA + i));
        } else {
			af_counter[option_controller][i] = 0;
			af_flag[option_controller][i] = 0;
        }
	}

	return buttons;
}


/*------------------------------------------------------
	۫ëȫի髰
------------------------------------------------------*/

static u8 apply_hotkey(u8 value)
{
	int i, button;

	button = P1_AB;
	for (i= 0; i < 11; i++)
	{
		if (input_flag[button]) value &= hotkey_mask[i];
		button++;
	}

	return value;
}


/*------------------------------------------------------
	NEOGEO CDZ ȫ1
------------------------------------------------------*/

static void update_inputport0(void)
{
	u8 value = 0xff;

	if (!option_controller)
	{
		if (input_flag[P1_UP])      value &= ~0x01;
		if (input_flag[P1_DOWN])    value &= ~0x02;
		if (input_flag[P1_LEFT])    value &= ~0x04;
		if (input_flag[P1_RIGHT])   value &= ~0x08;
		if (input_flag[P1_BUTTONA]) value &= ~0x10;
		if (input_flag[P1_BUTTONB]) value &= ~0x20;
		if (input_flag[P1_BUTTONC]) value &= ~0x40;
		if (input_flag[P1_BUTTOND]) value &= ~0x80;

		value = apply_hotkey(value);
	}

	neogeo_port_value[0] &= value;
}


/*------------------------------------------------------
	NEOGEO CDZ ȫ2
------------------------------------------------------*/

static void update_inputport1(void)
{
	u8 value = 0xff;

	if (option_controller)
	{
		if (input_flag[P1_UP])      value &= ~0x01;
		if (input_flag[P1_DOWN])    value &= ~0x02;
		if (input_flag[P1_LEFT])    value &= ~0x04;
		if (input_flag[P1_RIGHT])   value &= ~0x08;
		if (input_flag[P1_BUTTONA]) value &= ~0x10;
		if (input_flag[P1_BUTTONB]) value &= ~0x20;
		if (input_flag[P1_BUTTONC]) value &= ~0x40;
		if (input_flag[P1_BUTTOND]) value &= ~0x80;

		value = apply_hotkey(value);
	}

	neogeo_port_value[1] &= value;
}


/*------------------------------------------------------
	NEOGEO CDZ START/SELECTܫ
------------------------------------------------------*/

static void update_inputport2(void)
{
	u8 value = 0x0f;

	if (option_controller)
	{
		if (input_flag[P1_START])  value &= ~0x04;
		if (input_flag[P1_SELECT]) value &= ~0x08;
	}
	else
	{
		if (input_flag[P1_START])  value &= ~0x01;
		if (input_flag[P1_SELECT]) value &= ~0x02;
	}

	neogeo_port_value[2] &= value;
}


/******************************************************************************
	ݣȫ󫿫իμ
******************************************************************************/

/*------------------------------------------------------
	ݣȪѢ
------------------------------------------------------*/

void input_init(void)
{
	input_ui_wait = 0;

	memset(neogeo_port_value, 0xff, sizeof(neogeo_port_value));

	memset(af_flag, 0, sizeof(af_flag));
	memset(af_counter, 0, sizeof(af_counter));

	memset(input_flag, 0, sizeof(input_flag));
}


/*------------------------------------------------------
	ݣȪ
------------------------------------------------------*/

void input_shutdown(void)
{
}


/*------------------------------------------------------
	ݣȪ꫻ë
------------------------------------------------------*/

void input_reset(void)
{
	int i;
	memset(neogeo_port_value, 0xff, sizeof(neogeo_port_value));
	neogeo_port_value[2] = 0x0f;
	
	for (i = 0; i < 2; i++)
	   	reset_joystick(i);
}


/*------------------------------------------------------
	ݣȪ
------------------------------------------------------*/

void update_inputport(void)
{
	int i, j;
	u32 buttons;

	memset(neogeo_port_value, 0xff, sizeof(neogeo_port_value));
	neogeo_port_value[2] = 0x0f;

	for (i = 0; i < 2; i++) {
		buttons = read_joystick(i);
    	buttons = update_autofire(buttons);

		for (j = 0; j < MAX_INPUTS; j++)
			input_flag[j] = (buttons & (1 << j)) != 0;

		option_controller = i;
		update_inputport0();
		update_inputport1();
		update_inputport2();
	}

	if (input_flag[SNAPSHOT])
	{
		//save_snapshot();
	}
	if (input_flag[SWPLAYER])
	{
		if (!input_ui_wait)
		{
			option_controller ^= 1;
			//ui_popup(TEXT(CONTROLLER_PLAYERx), option_controller + 1);
			input_ui_wait = 30;
		}
	}
	if (input_ui_wait > 0) input_ui_wait--;
}



/*------------------------------------------------------
	/ ƣ
------------------------------------------------------*/

#ifdef SAVE_STATE

STATE_SAVE( input )
{
	state_save_long(&option_controller, 1);
}

STATE_LOAD( input )
{
	state_load_long(&option_controller, 1);
}

#endif /* SAVE_STATE */
