#include <stdlib.h>
#include <stdio.h>
#include "neocd.h"
#include "timer.h"
#include "ym2610.h"

Uint32 timer_count;
Uint32 timers[2];
static int nb_interlace = 256;
static Uint32 inc;

Uint32 timer_get_time(void) {
    return timer_count;
}

void set_timer(int ch, Uint32 duration) {
	if(duration)
		timers[ch] = timer_count + duration;
	else
		timers[ch] = 0;
}

void free_all_timer(void) {
	timers[0] = timers[1] = 0;
}

void my_timer(void) {
	timer_count += inc;		/* 16ms par frame */

	if(timers[0] && (timer_count > timers[0])) { timers[0] = 0;YM2610TimerOver(0); }
	if(timers[1] && (timer_count > timers[1])) { timers[1] = 0;YM2610TimerOver(1); }
}

void timer_init(int ispal) {
	if (ispal) { // PAL mode
		inc = ((double) (0.02) / nb_interlace) * (1<<TIMER_SH);
	} else { // NTSC mode
		inc = ((double) (0.016667) / nb_interlace) * (1<<TIMER_SH);
	}

	timer_count = 0;
	timers[0] = timers[1] = 0;
}
