/*******************************************
**** VIDEO.H - Video Hardware Emulation ****
****            Header File             ****
*******************************************/

#ifndef	VIDEO_H
#define VIDEO_H

#include "neocd.h"

/*-- Defines ---------------------------------------------------------------*/
#define VIDEO_TEXT	0
#define VIDEO_NORMAL	1
#define	VIDEO_SCANLINES	2

/*-- Global Variables ------------------------------------------------------*/
extern u16 neogeo_vidram16[0x20000 / 2];
extern u16 neogeo_vidram16_offset;
extern u16 neogeo_vidram16_modulo;

extern u16 *neogeo_paletteram16;
extern u16 neogeo_palettebank16[2][0x2000 / 2];
extern u32 neogeo_palette_index;

extern u32 *video_palette;
extern u32 video_palettebank[2][0x2000 / 2];
extern u16 video_clut16[0x8000];

extern u8  video_fix_usage[0x20000 / 32];
extern u8  video_spr_usage[0x400000 / 128];

extern int video_enable;
extern int spr_disable;
extern int fix_disable;

extern u16 *video_line_ptr[224];

extern SDL_Surface *screen;
extern SDL_Surface *video_buffer;
extern SDL_Surface *game_title;

/*-- video.c functions ----------------------------------------------------*/
int  neogeo_video_init(void);
void neogeo_video_reset(void);
void video_shutdown(void);
void video_draw_screen(int scanline);
void video_draw_title(void);

/*-- draw_fix.c functions -------------------------------------------------*/
void video_draw_fix(void);
void fixputs(Uint16 x, Uint16 y, const char * string);

#endif /* VIDEO_H */
